/*
`\itshape 二次剩余  求解`x^2 = a (mod n)
int modSqrt(int a , int n) : `\itshape 返回-1(无解)   x(较小根, 另一根`n-x)
*/

int	powMod(int a , int p , int M)
{
	int	ret = 1;
	int	w = a;
	while (p)
	{
		if (p & 1) ret = (long long)ret * w % M;
		p >>= 1; w = (long long)w * w % M;
	}
	return	ret;
}

// x*x = a (mod n), n is prime and gcd(a,n)=1. 
// return -1 (no solution)
// x and (n - x) are two solutions
int	modSqrt(int a , int n)
{
	if (n == 2) return a % n;
	if (powMod(a, (n - 1) / 2, n) != 1) return -1;

	int	b , k , i , x;
	if (n % 4 == 3)
		x = powMod(a , (n + 1) / 4, n);
	else
	{
		for (b = 2; powMod(b, (n-1)/2, n) == 1; b ++);
		i = (n - 1) / 2; k = 0;
		do {
			i /= 2; k /= 2;
			if ( ((long long)powMod(a,i,n) * powMod(b,k,n) + 1) % n == 0)
				k += (n - 1) / 2;
		} while (i % 2 == 0);
		x = (long long)powMod(a, (i+1)/2, n) * powMod(b, k/2, n) % n;
	}

	if (x * 2 > n) x = n - x;
	return x;
}

int	main()
{
	int	t , a , n;
	for (scanf("%d" , &t); t > 0; t --)
	{
		scanf("%d%d" , &a , &n);
		int	x = modSqrt( a , n );
		if (x < 0) puts("No root");
		else printf("%d %d\n" , x , n - x);
	}

	return 0;
}

