//Romberg
double x0, Y0, r0, r;
inline double f(double a)
{
	if ((a*a+r0*r0-r*r)/a/r0/2<=-1.0) return 0;
	if ((a*a+r0*r0-r*r)/a/r0/2>=1.0) return 0;
	return a*(Pi-2*asin((a*a+r0*r0-r*r)/a/r0/2))*log(a);
}
const int n = 21;
double calc(double l, double r)
{
	double T[n][n];
	int i,j,k;
	T[0][0] = (f(l)+f(r))/2;
	for (i=1; i<n; i++)
	{
		T[i][0] = 0;
		int tot = 1<<i;
		for (j=1; j<tot; j+=2)
			T[i][0] += f( (r-l)*j/ tot + l );
		T[i][0] += T[i-1][0]*(tot/2);
		T[i][0] /= tot;
	}
	double pp[n];
	pp[0] = 1;
	for (i=1; i<n; i++)
		pp[i] = pp[i-1] * 4;
	for (j=1; j<n; j++)
	{
		for (k=0; k<=n-1-j; k++)
			T[k][j] = (T[k+1][j-1]*pp[j] - T[k][j-1]) / ( pp[j] - 1 );
	}
	return T[0][n-1]*2*(r-l);
}

