// FFT
#define ONE 100000
#define Max(a, b) ((a) > (b) ? (a) : (b))
#define Min(a, b) ((a) < (b) ? (a) : (b))
#define sqr(a) ((a) * (a))
#define PI 3.14159265358979323846264338327950288
char Input[300005];
long long NumA[270000], NumB[270000], NumAns[270000];
int lenA, lenB, lenAns, T, N;
complex ValA[270000], ValB[270000], ValAns[270000];
complex tmp[2][270000], Const[18][270000];

inline int tmpCalc(int x) {
	return (x == 1 ? 1 : tmpCalc((x + 1) / 2) * 2);
}
inline int Get(int x) {
	return (x < 0 ? 0 : Input[x] - '0');
}
inline int Read(int *lenres, long long *res) {
	int i, j;
	scanf("%s", Input);
	i = strlen(Input), j = 0;
	for (i --; i >= 0; i -= 5) {
		res[j] = Get(i - 4) * 10000 + Get(i - 3) * 1000 + Get(i - 2) * 100
			+ Get(i - 1) * 10 + Get(i);
		j ++;
	}
	(*lenres) = j;
	return 0;
}
inline int Log(int x) {
	return (x == 1 ? 0 : (Log(x / 2) + 1));
}
inline int CalcVal(long long *Num, int len, complex *res) {
	int i, j, k, l, t, logi;
	int p1, p2;
	complex *last, *cnt, *temp;
	for (i = 0; i < N; i ++)
		tmp[0][i] = (i < len ? Num[i] : 0);
	last = tmp[0];
	cnt = tmp[1];
	for (i = 2; i <= N; i *= 2) {
		logi = Log(i);
		l = N / i;
		if (l > len)
			for (k = 0; k < N; k += l)
				memset(&cnt[k + len], 0, sizeof(complex) * (l - len));
		for (j = 0; j < len && j < l; j ++) {
			p1 = j;
			p2 = j + l;
			for (k = j, t = 0; k < N; k += l, t ++) {
				cnt[k] = last[p1] + Const[logi][t] * last[p2];
				p1 += 2 * l;
				p2 += 2 * l;
				p1 -= (p1 >= N ? N : 0);
				p2 -= (p2 >= N ? N : 0);
			}
		}
		temp = last;
		last = cnt;
		cnt = temp;
	}
	for (i = 0; i < N; i ++)
		res[i] = last[i];
	return 0;
}
inline int CalcCoef(long long *Num, complex *val) {
	int i, j, k, l, t, logi;
	int p1, p2;
	complex *last, *cnt, *temp;
	memcpy(tmp, val, sizeof(complex) * N);
	last = tmp[0];
	cnt = tmp[1];
	for (i = N; i >= 2; i /= 2) {
		logi = Log(i);
		l = N / i;
		for (j = 0; j < l; j ++) {
			p1 = j;
			p2 = j + l;
			for (k = j, t = 0; k < N / 2; k += l, t ++) {
				cnt[p1] = (last[k] + last[k + N / 2]) / 2.0;
				cnt[p2] = (last[k] - last[k + N / 2]) / Const[logi][t] / 2;
				p1 += 2 * l;
				p2 += 2 * l;
				p1 -= (p1 >= N ? N : 0);
				p2 -= (p2 >= N ? N : 0);
			}
		}
		temp = last;
		last = cnt;
		cnt = temp;
	}
	for (i = 0; i < N; i ++)
		Num[i] = (long long)(creal(last[i]) + 0.5);
	return 0;
}
int main() {
	int i, j, k;
	scanf("%d", &T);
	for (i = 0; i < 18; i ++)
		for (j = 0; j < (1 << i); j ++)
			Const[i][j] = cexp(I * 2.0 * PI * j / (1 << i));
	while (T --) {
		Read(&lenA, NumA); Read(&lenB, NumB);
		N = tmpCalc(lenA + lenB);
		CalcVal(NumA, lenA, ValA); CalcVal(NumB, lenB, ValB);
		for (i = 0; i < N; i ++)
			ValAns[i] = ValA[i] * ValB[i];
		CalcCoef(NumAns, ValAns);
		j = 0;
		for (i = 0; i < N - 1; i ++) {
			NumAns[i + 1] += NumAns[i] / ONE;
			NumAns[i] %= ONE;
		}
		for (i = N - 1; i >= 0; i --)
			if (j || NumAns[i]) {
				if (j)
					for (k = ONE / 10; k > 1; k /= 10)
						if (NumAns[i] < k)
							printf("0");
				printf("%lld", NumAns[i]);
				j = 1;
			}
		if (!j)
			printf("0");
		printf("\n");
	}
	return 0;
}

