// Gabow
// Matching in general Graph O(V^3)
const int MAXN = 100;
const int MAXNODE = MAXN + 1;

int a[MAXN][MAXN];

int n;
int G[MAXNODE][MAXNODE];
int label[MAXNODE], mate[MAXNODE], first[MAXNODE];
queue<int> Q;

void restorePath(int v, int w) {
	int t = mate[v];

	mate[v] = w;
	if (mate[t] != v) return;
	if (label[v] <= n) {
		mate[t] = label[v];
		restorePath(label[v], t);
		return;
	}

	int x = (label[v] - 1) / n, y = (label[v] - 1) % n + 1;
	restorePath(x, y);
	restorePath(y, x);
}
void setEdgeLabel(int x, int y) {
	int r = first[x], s = first[y];
	if (r == s) return;

	int code = x * n + y;
	label[r] = label[s] = -code;

	for (;;) {
		if (s > 0) {
			int t;
			t = r, r = s, s = t;
		}
		r = first[label[mate[r]]];
		if (label[r] != -code) {
			label[r] = -code;
			continue;
		}
		else
			break;
	}

	for (int i = 0; i < 2; ++i) {
		int v = i ? first[x]: first[y];
		while (v != r) {
			Q.push(v);
			label[v] = code;
			first[v] = r;
			v = first[label[mate[v]]];
		}
	}

	for (int i = 0; i <= n; ++i)
		if (label[i] >= 0 && label[first[i]] >= 0)
			first[i] = r;
}
void Gabow() {
	memset(mate, 0, sizeof(mate));
	for (int u = 1; u <= n; ++u) {
		if (mate[u]) continue;

		memset(label, -1, sizeof(label));
		label[u] = first[u] = 0;

		while (!Q.empty()) Q.pop(); 

		Q.push(u); 
		while (!Q.empty()) { 
			int x = Q.front(); 
			Q.pop(); 
			bool done = false; 
			for (int y = 1; y <= n; ++y) { 
				if (!G[x][y]) continue; 

				if (!mate[y] && y != u) {
					mate[y] = x;
					restorePath(x, y);
					done = true;
					break;
				}

				if (label[y] >= 0) {
					setEdgeLabel(x, y);
					continue;
				}

				int v = mate[y];
				if (label[v] < 0) {
					label[v] = x;
					first[v] = y;
					Q.push(v);
					continue;
				}

			}

			if (done == true) break;
		}
	}

	int total = 0;
	for (int i = 1; i <= n; ++i)
		if (mate[i]) ++total;

	printf("%d\n", total);
	for (int i = 1; i <= n; ++i)
		if (mate[i] > i)
			printf("%d %d\n", i, mate[i]);

}
int main() {
	scanf("%d", &n);
	memset(G, 0, sizeof(G));
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			if (i != j)
				;// G[i][j] = ........................
	Gabow();
	return 0;
}

