//HalfPlane
//O(N^2)
const int maxn = 50000 + 5;
const double EPS = 1E-8;
const double INF = 1e4;
struct Tline
{
	double a, b, c;
};

struct Tpoint
{
	double x, y;
};

Tline Line[maxn];
Tpoint point[maxn], tmp[maxn];
bool imp[maxn];
int n;

Tline get_line(Tpoint p1, Tpoint p2)
{
	Tline ret;
	ret.a = p2.y - p1.y;
	ret.b = p1.x - p2.x;
	ret.c = p2.x * p1.y - p1.x * p2.y;
	return ret;
}
Tpoint get_point(Tline p, Tline q)
{
	Tpoint ret;
	ret.x = (p.b * q.c - q.b * p.c) / (q.b * p.a - q.a * p.b);
	ret.y = (p.a * q.c - q.a * p.c) / (q.a * p.b - p.a * q.b);
	return ret;
}
double dbl(Tpoint a, Tpoint b, Tpoint c)
{
	return (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
}
double half_plane()
{
	int m = 4;
	point[0].x = 0; point[0].y = 0;
	point[1].x = 0; point[1].y = INF;
	point[2].x = INF; point[2].y = INF;
	point[3].x = INF; point[3].y = 0;

	for (int i = 0; i < n; ++i)
	{
		Tpoint p1, p2;
		Tline line = Line[i];

		point[m] = point[0];
		int k = 0;
		for (int j = 0; j <= m; ++j)
		{
			imp[j] = line.a * point[j].x + line.b * point[j].y + line.c <= 0;
			if (j && imp[j - 1] ^ imp[j]) tmp[k++] = get_point(get_line(point[j - 1], point[j]), line);
			if (imp[j] && j < m) tmp[k++] = point[j];
		}

		m = k;
		for (int j = 0; j < m; ++ j) point[j] = tmp[j];
		if (m < 3) break;
	}

	double area = 0;
	for (int i = 1; i < m - 1; ++i)
		area += fabs(dbl(point[0], point[i], point[i + 1]));

	return area / 2.0;
}
