//Hopcroft:

//Bipartite graph maximum matching
//N points on the left, M points on the right

const int maxN = 100000 + 5;
const int maxE = 300000 + 5;

int N, M;
int E;
int pv[maxE], next[maxE];
int a[maxN], links[maxN], visit[maxN];
int que[maxN], prev[maxN];

void addEdge(int x, int y)
{
	pv[++E] = y, next[E] = a[x], a[x] = E;
}
int Hopcroft()
{
	memset(visit, 0, sizeof(visit));
	memset(links, 0, sizeof(links));
	for (int i = 1; i <= N; ++ i)
	{
		int h = 0, t = 0;
		for (int tmp = a[i]; tmp > 0; tmp = next[tmp])
			if (visit[pv[tmp]] < i)
			{
				que[++t] = pv[tmp];
				prev[pv[tmp]] = 0;
				visit[pv[tmp]] = i;
			}
		int k = 0;
		while (h < t)
		{
			int x = que[++h];
			if (!links[x])
			{
				k = x; break;
			}
			for (int tmp = a[links[x]]; tmp > 0; tmp = next[tmp])
				if (visit[pv[tmp]] < i)
				{
					que[++t] = pv[tmp];
					prev[pv[tmp]] = x;
					visit[pv[tmp]] = i;
				}
		}
		if (k == 0) continue;
		while (prev[k])
		{
			links[k] = links[prev[k]];
			k = prev[k];
		}
		links[k] = i;
	}
	int ret = 0;
	for (int k = 1; k <= M; ++ k)
		ret += (links[k] > 0);
	return ret;
}

