//3D convex hull
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>
#define Eps 1E-8
int T;
int N;
double Points[1005][3];
int Mark[1005][1005];
int opp[1005][1005];
int Queue[10005][2];
int Front, Back;
double S, V;
int cmp(const void *a, const void *b) {
	double *pa = (double *)a, *pb = (double *)b;
	if (pa[0] != pb[0])
		return (pa[0] > pb[0] ? 1 : -1);
	if (pa[1] != pb[1])
		return (pa[1] > pb[1] ? 1 : -1);
	return (pa[2] > pb[2] ? 1 : -1);
}
double sqr(double x) {
	return x * x;
}
double myabs(double x) {
	return (x > 0 ? x : -x);
}
int Minus(double *res, double *pa, double *pb) {
	int i;
	for (i = 0; i < 3; i ++)
		res[i] = pa[i] - pb[i];
	return 0;
}
int Cross(double *res, double *pa, double *pb) {
	res[0] = pa[1] * pb[2] - pa[2] * pb[1];
	res[1] = pa[2] * pb[0] - pa[0] * pb[2];
	res[2] = pa[0] * pb[1] - pa[1] * pb[0];
	return 0;
}
double Dot(double *pa, double *pb) {
	return (pa[0] * pb[0] + pa[1] * pb[1] + pa[2] * pb[2]);
}
double len(double *pa) {
	return sqrt(sqr(pa[0]) + sqr(pa[1]) + sqr(pa[2]));
}
int main() {
	int i, j, k, l, m;
	double t1[3], t2[3], t3[3], t4[3];
	double t, tmp;
	scanf("%d", &T);
	while (T --) {
		scanf("%d", &N);
		for (i = 0; i < N; i ++)
			for (j = 0; j < 3; j ++)
				scanf("%lf", &Points[i][j]);
		qsort(Points, N, sizeof(double) * 3, cmp);
		for (i = j = 1; i < N; i ++) {
			if (myabs(Points[i][0] - Points[j - 1][0]) < Eps && myabs(Points[i][1] - Points[j - 1][1]) < Eps && myabs(Points[i][2] - Points[j - 1][2]) < Eps)
				continue;
			Points[j][0] = Points[i][0];
			Points[j][1] = Points[i][1];
			Points[j][2] = Points[i][2];
			j ++;
		}
		N = j;
		for (i = 0; i < N; i ++)
			for (j = 0; j < N; j ++)
				Mark[i][j] = 0;
		j = 0;
		for (i = 0; i < N; i ++)
			if (Points[i][2] < Points[j][2])
				j = i;
		k = -1;
		for (i = 0; i < N; i ++)
			if (i != j)
				if (k == -1 || (sqr(Points[k][0] - Points[j][0]) + sqr(Points
								[k][1] - Points[j][1])) * sqr(Points[i][2] - Points[j][2]) < (sqr(Points[
									i][0] - Points[j][0]) + sqr(Points[i][1] - Points[j][1])) * sqr(Points[k]
									[2] - Points[j][2]))
					k = i;
		l = -1;
		for (i = 0; i < N; i ++)
			if (i != k && i != j) {
				if (l == -1) {
					l = i;
					continue;
				}
				Minus(t1, Points[k], Points[j]);
				Minus(t2, Points[l], Points[j]);
				Minus(t3, Points[i], Points[j]);
				Cross(t4, t1, t2);
				if (Dot(t3, t4) > 0)
					l = i;
			}
		Mark[j][k] ++;
		Mark[k][j] ++;
		Mark[j][l] ++;
		Mark[l][j] ++;
		Mark[k][l] ++;
		Mark[l][k] ++;
		opp[j][k] = opp[k][j] = l;
		opp[j][l] = opp[l][j] = k;
		opp[k][l] = opp[l][k] = j;
		Front = 3;
		Back = 0;
		Queue[0][0] = Queue[1][0] = j;
		Queue[0][1] = Queue[2][0] = k;
		Queue[1][1] = Queue[2][1] = l;
		S = V = 0;
		Minus(t1, Points[k], Points[j]);
		Minus(t2, Points[l], Points[j]);
		Minus(t3, Points[0], Points[j]);
		Cross(t4, t1, t2);
		S += len(t4) / 2.0;
		V += myabs(Dot(t3, t4)) / 6.0;
		while (Front > Back) {
			j = Queue[Back][0];
			k = Queue[Back][1];
			if (Mark[j][k] == 2) {
				Back ++;
				continue;
			}
			l = opp[j][k];
			Minus(t1, Points[k], Points[j]);
			Minus(t2, Points[l], Points[j]);
			Cross(t3, t1, t2);
			t = -1;
			for (i = 0; i < N; i ++)
				if (i != j && i != k && i != l) {
					Minus(t2, Points[i], Points[j]);
					Cross(t4, t1, t2);
					if ((tmp = acos(Dot(t3, t4) / len(t3) / len(t4))) > t) {
						t = tmp;
						m = i;
					}
				}
			Mark[m][j] ++;
			Mark[m][k] ++;
			Mark[j][m] ++;
			Mark[k][m] ++;
			opp[j][m] = opp[m][j] = k;
			opp[k][m] = opp[m][k] = j;
			Minus(t1, Points[k], Points[j]);
			Minus(t2, Points[m], Points[j]);
			Minus(t3, Points[0], Points[j]);
			Cross(t4, t1, t2);
			S += len(t4) / 2.0;
			V += myabs(Dot(t3, t4)) / 6.0;
			Queue[Front][0] = j;
			Queue[Front][1] = m;
			Front ++;
			Queue[Front][0] = k;
			Queue[Front][1] = m;
			Front ++;
			Back ++;
		}
		printf("%lf %lf\n", S, V);
	}
	return 0;
}

