//KM
// O(V^4)

const int maxN = 100;
const int maxnum = 1000000000;

int N;
int map[maxN][maxN];
int lx[maxN], ly[maxN];
bool vx[maxN], vy[maxN];
int links[maxN];

bool dfs(int i)
{
	vx[i] = 1;
	for (int j = 1; j <= N; ++ j)
		if (!vy[j] && lx[i] + ly[j] == map[i][j])
		{
			vy[j] = 1;
			int q = links[j];
			links[j] = i;
			if (q == 0 || dfs(q)) return 1;
			links[j] = q;
		}
	return 0;
}

void KM()
{
	memset(lx, 0, sizeof(lx));
	memset(ly, 0, sizeof(ly));
	memset(links, 0, sizeof(links));

	for (int i = 1; i <= N; ++ i)
		for (int j = 1; j <= N; ++ j)
			if (map[i][j] > lx[i]) lx[i] = map[i][j];

	for (int k = 1; k <= N; ++ k)
		while (1)
		{
			memset(vx, 0, sizeof(vx));
			memset(vy, 0, sizeof(vy));
			if (dfs(k)) break;

			int delta = maxnum;
			for (int i = 1; i <= totX; ++ i) if (vx[i])
				for (int j = 1; j <= totY; ++ j) if (!vy[j])
					if (lx[i] + ly[j] - map[i][j] < delta)
						delta = lx[i] + ly[j] - map[i][j];

			if (delta == maxnum) break;

			for (int i = 1; i <= N; ++ i)
			{
				if (vx[i]) lx[i] -= delta;
				if (vy[i]) ly[i] += delta;
			}
		}
}
