//`半平面求交`.cpp
const int maxn=2100+5;
const double deltaP=0.123456789123456789;
const double eps=1e-7;
int n;
double X[maxn],Y[maxn];
double A[maxn],B[maxn],C[maxn],P[maxn];
int split;
int size1,Q1[maxn],size2,Q2[maxn],size;
double cut1[maxn],cut2[maxn],cut[maxn];
int node;
double pX[maxn],pY[maxn];
inline double sqr(double X)
{
	return X*X;
}
void init()
{
	scanf("%d",&n);
	for (int i=1;i<=n;i++)
	{
		double _X,_Y;
		scanf("%lf%lf",&_X,&_Y);
		X[i]=_X*cos(deltaP)-_Y*sin(deltaP);
		Y[i]=_X*sin(deltaP)+_Y*cos(deltaP);
	}
	X[n+1]=X[1];Y[n+1]=Y[1];
	X[0]=X[n];Y[0]=Y[n];
	double S=0;
	for (int i=1;i<=n;i++)
		S+=X[i]*(Y[i+1]-Y[i-1]);
	if (S<0)
		for (int i=1;i<=n;i++)
			X[i]=-X[i];
	X[n+1]=X[1];Y[n+1]=Y[1];
	X[0]=X[n];Y[0]=Y[n];
	for (int i=1;i<=n;i++)
	{
		A[i]=+(Y[i]-Y[i+1]);
		B[i]=-(X[i]-X[i+1]);
		C[i]=X[i]*Y[i+1]-Y[i]*X[i+1];
		P[i]=A[i]*(X[i]+X[i+1])/2.0+B[i]*(Y[i]+Y[i+1]+1.0)/2.0+C[i];
	}
}
inline double crossX(int u,int v)
{
	double a1=A[u],b1=B[u],c1=C[u];
	double a2=A[v],b2=B[v],c2=C[v];
	return (b1*c2-b2*c1)/(a1*b2-a2*b1);
}
inline void intersect(int u,int v,double &X0,double &Y0)
{
	double a1=A[u],b1=B[u],c1=C[u];
	double a2=A[v],b2=B[v],c2=C[v];
	double t=a1*b2-a2*b1;
	X0=+(b1*c2-b2*c1)/t;
	Y0=-(a1*c2-a2*c1)/t;
}
void Qsort(int H,int T)
{
	if (H>=T)
		return;
	double key=P[(H+T)/2];
	int i=H,j=T;
	for (;i<=j;)
	{
		for (;P[i]<key;i++);
		for (;P[j]>key;j--);
		if (i<=j)
		{
			swap(A[i],A[j]);
			swap(B[i],B[j]);
			swap(C[i],C[j]);
			swap(P[i],P[j]);
			i++;
			j--;
		}
	}
	Qsort(H,j);
	Qsort(i,T);
}
void solve(int H,int T,int &size,int Q[],double cut[])
{
	size=0;
	for (int i=H;i<=T;i++)
	{
		for (;size>=2 && crossX(Q[size-1],i)<=cut[size-1]+eps;size--);
		if (size==0)
			cut[size]=-1e8;
		else
			cut[size]=crossX(Q[size],i);
		Q[++size]=i;
	}
	cut[size]=1e8;
}
double process()
{
	for (int i=1,j=n;i<=j;i++,j--)
	{
		for (;P[i]>0;i++);
		for (;P[j]<0;j--);
		if (i<=j)
		{
			swap(A[i],A[j]);
			swap(B[i],B[j]);
			swap(C[i],C[j]);
			swap(P[i],P[j]);
		}
	}
	int split;
	for (split=1;P[split]>0;split++);
	for (int i=1;i<=n;i++)
		P[i]=-A[i]/B[i];
	Qsort(1,split-1);
	Qsort(split,n);
	for (int i=split;i<=(n+split)/2;i++)
	{
		swap(A[i],A[n+split-i]);
		swap(B[i],B[n+split-i]);
		swap(C[i],C[n+split-i]);
		swap(P[i],P[n+split-i]);
	}
	solve(1,split-1,size1,Q1,cut1);
	solve(split,n,size2,Q2,cut2);
	size=0;
	for (int i=1;i<size1;i++)
		cut[++size]=cut1[i];
	for (int i=1;i<size2;i++)
		cut[++size]=cut2[i];
	sort(cut+1,cut+size+1);
	int u,v,lu=-1,lv=-1,ru=-1,rv=-1;
	u=1;
	v=1;
	for (int i=1;i<=size;i++)
		if (i==1 || fabs(cut[i]-cut[i-1])>eps)
		{
			double keyX=cut[i];
			for (;cut1[u]<keyX-eps;u++);
			for (;cut2[v]<keyX-eps;v++);
			double Y1=-(A[Q1[u]]*keyX+C[Q1[u]])/B[Q1[u]];
			double Y2=-(A[Q2[v]]*keyX+C[Q2[v]])/B[Q2[v]];
			if (Y1<Y2)
			{
				lu=u;
				lv=v;
				break;
			}
		}
	u=size1;
	v=size2;
	for (int i=size;i>0;i--)
		if (i==size || fabs(cut[i]-cut[i+1])>eps)
		{
			double keyX=cut[i];
			for (;cut1[u-1]>keyX+eps;u--);
			for (;cut2[v-1]>keyX+eps;v--);
			double Y1=-(A[Q1[u]]*keyX+C[Q1[u]])/B[Q1[u]];
			double Y2=-(A[Q2[v]]*keyX+C[Q2[v]])/B[Q2[v]];
			if (Y1<Y2)
			{
				ru=u;
				rv=v;
				break;
			}
		}
	if (lu==-1 || ru==-1)
		return 0.0;
	node=1;
	intersect(Q1[lu],Q2[lv],pX[1],pY[1]);
	for (int i=lv;i<rv;i++)
	{
		node++;
		intersect(Q2[i],Q2[i+1],pX[node],pY[node]);
	}
	node++;
	intersect(Q1[ru],Q2[rv],pX[node],pY[node]);
	for (int i=ru-1;i>=lu;i--)
	{
		node++;
		intersect(Q1[i],Q1[i+1],pX[node],pY[node]);
	}
	pX[node+1]=pX[1];pY[node+1]=pY[1];
	pX[0]=pX[node];pY[0]=pY[node];
	double result=0;
	for (int i=1;i<=n;i++)
		result+=pX[i]*(pY[i+1]-pY[i-1]);
	return fabs(result)/2.0;
}
int main()
{
	init();
	double ret=process();
	printf("%lf\n",ret);
	return 0;
}

