//AVL.cpp
int max(int a,int b)
{
	return (a>b)?a:b;
}
class TAVLnode
{
	public:
		//
		int key,count;
		TAVLnode() {depth=0;left=NULL;right=NULL;}
		//
		int depth;
		TAVLnode *left,*right;
};
class TAVLtree
{
	public:
		TAVLnode *root,*t1,*t2;
		TAVLtree() {root=NULL;}
		TAVLtree(TAVLnode *p) {root=p;}
		bool better(TAVLnode *p1,TAVLnode *p2);
		void new_node(TAVLnode *&p);
		int get_depth(TAVLnode *p);
		void check_balance(TAVLnode *&p);
		void check_data(TAVLnode *p);
		void turnLL(TAVLnode *&p);
		void turnLR(TAVLnode *&p);
		void turnRL(TAVLnode *&p);
		void turnRR(TAVLnode *&p);
		void collect();
		void collect_inner(TAVLnode *&p);
		void addnode(TAVLnode *newnode);
		void addnode_inner(TAVLnode *&p,TAVLnode *newnode);
};
TAVLnode *root;
void TAVLtree::check_data(TAVLnode *p)
{
	p->count=1;
	if (p->left!=NULL)
		p->count+=p->left->count;
	if (p->right!=NULL)
		p->count+=p->right->count;
	p->depth=max(get_depth(p->left),get_depth(p->right))+1;
}
bool TAVLtree::better(TAVLnode *p1,TAVLnode *p2)
{
	return (p1->key<p2->key);
}
void TAVLtree::new_node(TAVLnode *&p)
{//为p申请空间
	p=new TAVLnode;
	p->left=p->right=NULL;
}
int TAVLtree::get_depth(TAVLnode *p)
{
	return (p==NULL)?0:p->depth;
}
void TAVLtree::turnLL(TAVLnode *&p)
{
	t1=p->left;
	p->left=t1->right;
	t1->right=p;
	p=t1;
	check_data(p->right);
	check_data(p);
}
void TAVLtree::turnRR(TAVLnode *&p)
{
	t1=p->right;
	p->right=t1->left;
	t1->left=p;
	p=t1;
	check_data(p->left);
	check_data(p);
}
void TAVLtree::turnLR(TAVLnode *&p)
{
	t1=p->left;
	t2=t1->right;
	t1->right=t2->left;
	p->left=t2->right;
	t2->left=t1;
	t2->right=p;
	p=t2;
	check_data(p->left);
	check_data(p->right);
	check_data(p);
}
void TAVLtree::turnRL(TAVLnode *&p)
{
	t1=p->right;
	t2=t1->left;
	t1->left=t2->right;
	p->right=t2->left;
	t2->right=t1;
	t2->left=p;
	p=t2;
	check_data(p->left);
	check_data(p->right);
	check_data(p);
}
void TAVLtree::check_balance(TAVLnode *&p)
{//进行旋转
	int Ld=get_depth(p->left);
	int Rd=get_depth(p->right);
	if (abs(Ld-Rd)>1)
	{
		if (Ld>Rd)
			if (get_depth(p->left->left)+1==Ld)
				turnLL(p);
			else
				turnLR(p);
		else
			if (get_depth(p->right->right)+1==Rd)
				turnRR(p);
			else
				turnRL(p);
	}
	check_data(p);
}
void TAVLtree::collect()
{
	collect_inner(root);
}
void TAVLtree::collect_inner(TAVLnode *&p)
{
	if (p!=NULL)
	{
		collect_inner(p->left);
		collect_inner(p->right);
		delete p;
	}
}
void TAVLtree::addnode_inner(TAVLnode *&p,TAVLnode *newnode)
{
	if (p==NULL)
	{
		new_node(p);
		memcpy(p,newnode,sizeof(TAVLnode));
		p->depth=1;
		p->left=p->right=NULL;
		check_data(p);
		return;
	}
	if (better(newnode,p))
		addnode_inner(p->left,newnode);
	else
		addnode_inner(p->right,newnode);
	check_balance(p);
	check_data(p);
}
void TAVLtree::addnode(TAVLnode *newnode)
{
	addnode_inner(root,newnode);
}

