/* ================================================================
`\itshape 二维几何`
*/
const double pi = acos(0.0) * 2.0;

struct Tpoint
{
	double x , y;
	Tpoint(){}
	Tpoint(double x0 , double y0){ x = x0; y = y0; }

	// `\itshape 逆时针旋转度`
	void	rotate90()
	{
		double	t = x;
		x = - y; y = t;
	}

	// `\itshape 非朴素法逆时针旋转theta角`
	void	rotate(double theta)	
	{
		double x0 = x;
		double y0 = y;

		theta = - theta;
		x = x0 * cos(theta) + y0 * sin(theta);
		y = - x0 * sin(theta) + y0 * cos(theta);
	}
};

//`\itshape 求直线AB , PQ的交点`
Tpoint	crossPoint(const Tpoint& A , const Tpoint& B , const Tpoint& P , const Tpoint& Q)
{
	double t = ((A.x - P.x) * (B.y - A.y) - (A.y - P.y) * (B.x - A.x))
		/ ((Q.x - P.x) * (B.y - A.y) - (Q.y - P.y) * (B.x - A.x));
	return	Tpoint( P.x + (Q.x - P.x) * t , P.y + (Q.y - P.y) * t );
}

/*
`\itshape 点P到直线AB距离`
	V = B - A; V.rotate90();
	`\itshape 垂足H = crossPoint(P , P + V , A , B);`
	`\itshape 距离d = dist(H , P);`

`\itshape 直线与圆的交点  	:	应先判距离!!!!!!!!!!!!!!!!!`
`\itshape 圆与圆的交点		:	应先判内含, 相离!!!!!!!!!!!!`
*/

`\itshape 直线方程  参数式 与 一般式 的转换`
`\begin{eqnarray*}
\begin{array}{c}
	x=P_x+td_x\\
	y=P_y+td_y
\end{array} &\to& -d_yx+d_xy+(P_xd_y-P_yd_x)=0\\
ax+by+c=0 &\to& \begin{array}{c}
P=\left[\frac{\displaystyle-ac}{\displaystyle a^2+b^2},\frac{\displaystyle-bc}{\displaystyle a^2+b^2}\right]\\
\vec{c}=[-b,a]
\end{array}
\end{eqnarray*}` 

/* ================================================================
`\itshape 半平面交` Half-plane O(N2)
*/
#include <cstdio>
#include <cstring>
#include <cmath>

struct			Thalf_plane
{
	Tpoint		p1 , p2; // `\itshape p1->p2的右边为有效区域`
};

int					n;
Thalf_plane		list	[limitSize];
double				area;

int				m;
Tpoint			polygon	[limitSize];	// `\itshape 最终结果 [0,m-1]`
Tpoint			tmp	[limitSize];
bool			valid	[limitSize];

void	half_plane_solve()
{
	m = 0;
	polygon[m ++] = Tpoint(0,0);
	polygon[m ++] = Tpoint(10000,0);
	polygon[m ++] = Tpoint(10000,10000);
	polygon[m ++] = Tpoint(0,10000);

	int	i , j , c;
	for (i = 0; i < n; i ++)
	{
		polygon[m] = polygon[0]; c = 0;
		for (j = 0; j <= m; j ++)
		{
			valid[j] = crossProduct(list[i].p1, list[i].p2, polygon[j])<=0;
			if (j && (valid[j] != valid[j - 1]))
				tmp[c ++] = crossPoint(list[i].p1, list[i].p2, polygon[j-1], polygon[j]);
			if (j < m && valid[j])
				tmp[c ++] = polygon[j];
		}
		m = c;
		for (j = 0; j < m; j ++)
			polygon[j] = tmp[j];
		if (m < 3) break;
	}

	polygon[m] = polygon[0];

	area = 0;
	for (i = 0; i < m; i ++)
		area += polygon[i].x * polygon[i + 1].y - polygon[i].y * polygon[i + 1].x;
	area /= 2.0;
}
